.nolist
; include \masm32\MasmBasic\MasmBasic.inc 
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
	LOOP_COUNT	= 100000		; 1000000 would be a typical value

.data
align 16
Src1	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.5678h"
	db "1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h1234.567h", 0

align 16
Src2	db "1234.567h", 0


.data?
Dest	db 100 dup(?)

.code
start:
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S1:
		mov esi, offset Src1
		jmp @F
		HasE:
		jmp @F
		HasDot:
		jmp @F
		HasH:
		jmp @F
		HasB:
		jmp @F
		HasY:
		jmp @F
		HasB1:
		jmp @F
		HasB2:
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; few jumps
				test al, al
				je @F
				or al, 20h
				cmp al, "e"
				je HasE
				cmp al, "."
				je HasDot
				cmp al, "h"
				je HasH
				cmp al, "b"
				je HasB
				cmp al, "y"
				je HasY
				cmp al, "("
				je HasB1
				cmp al, "("
				je HasB2
			.endif
		jmp @B
		@@:
		E1:
		sub esi, offset Src1
	counter_end
	print str$(eax), 9, "cycles  few jumps, "
	mov eax, E1
	sub eax, S1
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S2:
		mov esi, offset Src1
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					jmp @B
				.endif
				.if al=="h"
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		E2:
		sub esi, offset Src1
	counter_end
	print str$(eax), 9, "cycles many jumps, "
	mov eax, E2
	sub eax, S2
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S2x:
		mov esi, offset Src1
		@@:
			movzx eax, word ptr [esi]
			inc esi
			.if al>="0" && al<="9"
				mov al, ah
				inc esi
			.endif
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					jmp @B
				.endif
				.if al=="h"
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		E2x:
		sub esi, offset Src1
	counter_end
	print str$(eax), 9, "cycles many + xchg al, ah, "
	mov eax, E2x
	sub eax, S2x
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S2b:
		mov esi, offset Src1
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.elseif al=="."
					jmp @B
				.elseif al=="h"
					jmp @B
				.elseif al=="b"
					jmp @B
				.elseif al=="y"
					jmp @B
				.elseif al=="("
					jmp @B
				.elseif al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		E2b:
		sub esi, offset Src1
	counter_end
	print str$(eax), 9, "cycles elseif jumps, "
	mov eax, E2b
	sub eax, S2b
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S2c:
		mov esi, offset Src1
		@@:
			movzx eax, byte ptr [esi]
			inc esi
			.if al<"0" || al>"9"
				or al, 20h
				SWITCH eax
				CASE 20h
				jmp @F
				CASE "e"
				CASE "."
				CASE "h"
				CASE "b"
				CASE "y"
				CASE "("
				CASE ")"
				ENDSW
			.endif
		jmp @B
		@@:
		E2c:
		sub esi, offset Src1
	counter_end
	print str$(eax), 9, "cycles Switch, "
	mov eax, E2c
	sub eax, S2c
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S3:
		mov esi, offset Src2
		jmp @F
		Has2E:
		jmp @F
		Has2Dot:
		jmp @F
		Has2H:
		jmp @F
		Has2B:
		jmp @F
		Has2Y:
		jmp @F
		Has2B1:
		jmp @F
		Has2B2:
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"
				test al, al
				je @F
				or al, 20h
				cmp al, "e"
				je Has2E
				cmp al, "."
				je Has2Dot
				cmp al, "h"
				je Has2H
				cmp al, "b"
				je Has2B
				cmp al, "y"
				je Has2Y
				cmp al, "("
				je Has2B1
				cmp al, "("
				je Has2B2
			.endif
		jmp @B
		@@:
		E3:
		sub esi, offset Src2
	counter_end
	print str$(eax), 9, "cycles  few jumps, "
	mov eax, E3
	sub eax, S3
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		S4:
		mov esi, offset Src2
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					jmp @B
				.endif
				.if al=="h"
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		E4:
		sub esi, offset Src2
	counter_end
	print str$(eax), 9, "cycles many jumps, "
	mov eax, E4
	sub eax, S4
	print str$(eax), " bytes, len="
	print str$(esi), 13, 10

;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		mov eax, Val(offset Src1)
;	counter_end
;	print str$(eax), 9, "cycles Val(Src1)", 13, 10

;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		mov eax, Val(offset Src2)
;	counter_end
;	print str$(eax), 9, "cycles Val(Src2)", 13, 10


	inkey chr$(13, 10, "--- ok ---", 13)
	exit
end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]